#include <cmath>
#include <iostream>
#include "complexe.hpp"
#include "polynome_1.hpp"		   


void polynome::adresse(){
  cout<<"adresse :"<<coefs<<endl;
};

complexe polynome:: get(int i){
  complexe res;
  res= coefs[i];
  return res;
};

void polynome:: set(complexe x, int i){
  coefs[i] = x;
};

polynome  polynome:: operator + (polynome p){
  int degt;
  degt = max(deg,p.deg);
  polynome res(degt,a,b);
  polynome temp;
  
  if(deg < p.deg){ temp = this->convert(p.deg);
    for(int i=0;i<degt+1;i++){
      res.coefs[i] = temp.coefs[i] + p.coefs[i];
    }
  }
  if(deg > p.deg){ temp = p.convert(deg); 
    for(int i =0;i<degt+1;i++){
      res.coefs[i]= coefs[i] + temp.coefs[i];
    }
  }
  if(deg == p.deg){ 
    for(int i =0;i<degt+1;i++){
      res.coefs[i]= coefs[i] + p.coefs[i];  }
  }
  return res;
}  


polynome  polynome:: operator - (polynome p){
  int degt;
  degt = max(deg,p.deg);
  polynome res(degt,a,b);
  polynome temp;
  
  if(deg < p.deg){ temp = this->convert(p.deg);
    for(int i=0;i<degt+1;i++){
      res.coefs[i] = temp.coefs[i] - p.coefs[i];
    }
  }
  if(deg > p.deg){ temp = p.convert(deg); 
    for(int i =0;i<degt+1;i++){
      res.coefs[i]= coefs[i] - temp.coefs[i];
    }
  }
  if(deg == p.deg){ 
    for(int i =0;i<degt+1;i++){
      res.coefs[i]= coefs[i] - p.coefs[i];  }
  }
  return res;
}

polynome polynome:: operator * (polynome p){
  int degt=deg+p.deg;
  polynome res(degt,a,b);
  polynome temp, temp2;

  temp = this->convert(degt);
  temp2 = p.convert(degt);
  for(int i=0;i<degt+1;i++){
    for(int j=0;j<i+1;j++){
      res.coefs[i]=res.coefs[i]+temp.coefs[j]*temp2.coefs[i-j];
    }
  }
  return res;
} 

polynome & polynome::operator =(const polynome & p){
  if(&p != this){
    deg = p.deg;
    a = p.a;
    b = p.b;
    if(coefs != NULL){ delete [] coefs;}
    coefs = NULL;
    if(p.coefs != NULL){
      coefs = new complexe[deg+1];
      for(int i =0;i<deg+1;i++){
  	coefs[i]=p.coefs[i];
      }
    }
  }
  return *this;
}

complexe polynome::operator [](int i){
  return coefs[i];
}

complexe polynome::operator ()(complexe x){
  complexe res(0.0,0.0);
  complexe prod(0.0,0.0);
  for(int i =0;i<deg+1;i++){
    prod =complexe(1.0,0.0);
    for(int j=0;j<i;j++){ prod = prod*x; }
      res = res + coefs[i]*prod;
  }
  return res;
}

complexe polynome:: operator,(polynome p){
  polynome pro, prim;
  complexe res(0.0,0.0);

  pro = (*this)*p.conjuge();
  res = pro.integral();
  return res;
}

complexe polynome::norm2(){
  complexe n(0,0);
  n = (*this,*this);
  return n;
};

bool polynome:: operator < (polynome x){
  bool res = false;
  if(this->norm2() < x.norm2() ) { res = true;}
  return res;
};

bool polynome:: operator > (polynome x){
  bool res = false;
  if(this->norm2() > x.norm2()) { res = true;}
  return res;
};

bool polynome:: operator == (polynome x){
  bool res = false;
  if(this->norm2() == x.norm2()) { res = true;}
  return res;
};



polynome polynome::conjuge(){
  polynome res(deg);
  for(int i=0;i<deg+1;i++){
    res.coefs[i]=coefs[i].conjuge();
  }
  return res;
}

polynome polynome::derivative(){
  polynome res(deg-1,a,b);
  for(int i =1;i<deg+1;i++){
    res.coefs[i-1]= i*coefs[i];
  }
  return res;
};

polynome polynome::primitive(){
  polynome res(deg+1,a,b);
  for(int i=0;i<deg+1;i++){
    res.coefs[i+1]= (1.0/(i+1.0))*coefs[i];
  }
  res.coefs[0]=complexe(0.0,0.0);
  return res;
}

complexe polynome::integral(){
  complexe res(0.0,0.0);
  polynome primitive;
  primitive = this->primitive();
  res= primitive(complexe(b,0.0))-primitive(complexe(a,0.0));
  return res;
}

ostream & operator << (ostream & out,const polynome & p){
  for(int i=0;i<p.deg+1;i++){
    out<<"("<<p.coefs[i]<<")"<<"x^"<<i;
    if(i!= p.deg){ out<<" + ";}
  }
  return out;
}

istream & operator >>(istream & in, polynome & p){
  for(int i=0;i<p.deg+1;i++){
    cout<<" coef: "<<i<<endl;
    in >> p.coefs[i];
  }
  return in;
}

int polynome:: testu_1(){
  polynome P(2);
  polynome Q,R,S;
  complexe x(1.0,1.0), y(2.0,-1.0), z(1.0,0.0);

  *this = P;
  this->set(x,0); this->set(y,1); this->set(z,2);
  Q = this->derivative();
  R = this->primitive();
  S = *this+R;
  *this = S*Q;
  
  complexe x0(3.0,1.0), y0(8.0,-1.0);
  if((*this)[0] == x0 && (*this)[1] == y0){ return 0;}
  else { return 1;}
};

int polynome:: testu_2(){
  polynome P(1), Q,S;
  complexe x(1.0,0.0), y(2.0,0.0);
  complexe ps, ps0(4.0,0.0);

  P.set(x,0); P.set(y,1);
  *this = P;
  Q = this->derivative();
  ps=(*this,Q);
  if(ps == ps0){ return 0;}
  else { return 1;}
  
  return 0;
};

int polynome:: testu_3(){
  polynome P(1);
  polynome Q,S;
  complexe x(1.0,-1.0), y(2.0,0.0);
  bool a=false,b=false,c=false;

  P.set(x,0); P.set(y,1);
  S = P;
  *this = P;
  Q = this->derivative();
  a = (*this > Q);
  b = (Q < *this);
  c = (S == *this);
  if( a+b+c == 3) { return 0; }
  else { return 1; }

  return 0; 
}

int polynome:: all_testsu(){
  int c=0,t=0;
  polynome p;
  c=p.testu_1(); t = t +c;
  c=p.testu_2(); t = t +c;
  c=p.testu_3(); t = t +c;
  cout<<"Tests unitaires réussis, classe polynome: "<<3-t<<"/3"<<endl;
  return 0;
}
