//#ifndef POLYNOME_1_HPP
//#define POLYNOME_1_HPP
#include <cmath>
#include <iostream>
#include "complexe.hpp"
using namespace std;

class polynome {
  int deg;
  double a;
  double b;
  complexe * coefs;
public: 
  polynome (){
    deg = 0;
    a = 0.0;
    b= 1.0;
    coefs = NULL;
  }
  polynome (int degree){
    deg = degree;
    a = 0.0;
    b = 1.0;
    coefs = new complexe[degree+1];
    for(int i =0; i<deg+1;i++){
	    coefs[i] = complexe(0,0);
    }
  }
  polynome(int degree, double binf, double bsup){
    deg = degree;
    a = binf;
    b = bsup;
    coefs = new complexe[degree+1];
    for(int i =0; i<deg+1;i++){
	coefs[i] = complexe(0,0);
    }
  }
  polynome (const polynome & x){
    deg = x.deg;
    coefs = NULL;
    a = x.a; b = x.b;
    if(x.coefs != NULL){
      coefs = new complexe[deg+1];
      for(int i =0; i<deg+1;i++){
  	coefs[i] = x.coefs[i];
      }
    }
  }
  ~polynome (){
    if(coefs != NULL){
      delete [] coefs;
    }
  }
  complexe get(int);
  void set(complexe, int);
  void adresse();
  polynome primitive();
  polynome derivative();
  complexe integral();
  polynome conjuge();
  polynome operator + (polynome);
  polynome operator - (polynome);
  polynome operator * (polynome);
  polynome operator / (polynome);
  complexe operator , (polynome);
  complexe operator () (complexe);
  complexe operator [] (int i);
  polynome & operator = (const polynome &);
  complexe norm2();
  bool operator <(polynome);
  bool operator >(polynome);
  bool operator ==(polynome);
  friend ostream & operator<<(ostream & out, const polynome &);
  friend istream & operator>>(istream & in, polynome &);
  int testu_1();
  int testu_2();
  int testu_3();
  int all_testsu();

private:
  polynome convert(int deg2){
    if( deg2 < deg){
      cout<<"convertion pas possible"<<endl;
    }
    polynome res(deg2);
    for(int i=0;i<deg+1;i++){
	res.coefs[i] = coefs[i];
    }
    return res;   
  }
  
};		   


//#endif
